require "libs/util"
class=require "libs/middleclass"
camera=require("libs/gamera").new(0,0,65535,65535)
camera_mini=require("libs/gamera").new(0,0,65535,65535)
shake_cam= require("libs/shakycam").new(camera)
vec=require "libs/vector"
game={}


love.math.setRandomSeed(os.time())
local function camSet()
    local dr=game.car.body:getAngle()+math.pi
    local x,y=game.car.body:getPosition()
    local cr= camera:getAngle()
    local delta=dr-cr
    camera:setPosition(x,y)
    camera:setAngle(cr+(delta*3)*math.pi/200)

end

local function lapCheck()
    if game.car.posInRoad==math.ceil(#road.blocks/2) then game.lapToggle=true end
    if game.car.oPos==#road.blocks and game.car.posInRoad==1 and game.lapToggle==true then
        game.lap=game.lap+1
        game.lapToggle=false
    end
end



function love.load() 
    game.carIndex=0
    game.lap=1
    game.world = love.physics.newWorld(0,0)
    contact=require("contact")
    game.world:setCallbacks(contact.beginContact, contact.endContact,contact.pre,contact.post)
    love.physics.setMeter(64)
    road=require("objs/road4"):new()
    
    game.car=require("objs/car"):new(love.math.random()*0.3+0.8,love.math.random()*0.3+0.8,love.math.random()*0.3+0.8,love.math.random()*0.3+0.8)
    game.car:setPosition(road.blocks[1].body:getPosition())
    --game.car.isAICtrl=false
   
    game.npc={}
    for i=1,5 do
        game.npc[i]=require("objs/car"):new(love.math.random()*0.3+0.8,love.math.random()*0.3+0.8,love.math.random()*0.3+0.8,love.math.random()*0.3+0.8)
        game.npc[i]:setPosition(road.blocks[i+1].body:getPosition())
        game.npc[i].posInRoad=i+1
    end
    
    camera:setPosition(0,0)
    camera_mini:setWindow(650,10,150,150)
    camera_mini:setScale(0.1)

    game.car.ai=require("ai")
end

local function drawGrid()
    love.graphics.setColor(255, 255, 255, 100)
    for x=-3000,3000,500 do
        for y=-3000,3000,500 do
            love.graphics.line(x, -3000, x, 3000)
            love.graphics.line(-3000, y,3000, y)
        end
    end
end


function love.draw()
    
    camera:draw(function()
        road:draw()
        game.car:draw()
        for k,v in pairs(game.npc) do
            v:draw()
        end
    end)
    love.graphics.setColor(0, 255, 0, 255)
    love.graphics.rectangle("line", 640, 5, 160, 160)
    love.graphics.setColor(0, 0, 0, 255)
    love.graphics.rectangle("fill", 641, 6, 158, 159)
    camera_mini:draw(function()
        game.car:draw()
        road:draw()
        for k,v in pairs(game.npc) do
            v:draw()
        end
    end)
    love.graphics.setColor(255, 255, 255, 255)
    local text=[[
        press a,d to steer
        press w,s to hit the gas
        press space to drift
        press r to switch auto pilot and manual control
    ]]
    love.graphics.print(text, 100, 100)
    local v=math.getDistance(0,0,game.car.body:getLinearVelocity())
    game.text="speed:"..math.floor(v)
    love.graphics.print(game.text, 300, 100)
    if game.car.wrongWay then
        love.graphics.print("wrong way!!!", 300, 300)
    end
    if game.car.isAICtrl then
        love.graphics.print("auto pilot", 300, 200)
    end
    love.graphics.print("lap:"..game.lap, 400, 100)

    for k,v in pairs(road.miniMap) do
        love.graphics.circle("fill", v[1]+300, v[2]+400, 2)
    end

    love.graphics.setColor(0, 0, 255, 255)
    for k,v in pairs(game.npc) do
        local x,y=v.body:getPosition()
        love.graphics.circle("fill", (x-10000)/50+300, (y-10000)/50+400, 3)
    end

    love.graphics.setColor(255, 0, 0, 255)
    local x,y=game.car.body:getPosition()
    love.graphics.circle("fill", (x-10000)/50+300, (y-10000)/50+400, 3)
end

function love.update(dt) 
    local x,y=game.car.body:getPosition()
    local r= game.car.body:getAngle()
    game.car:update(dt)
    for k,v in pairs(game.npc) do
        v:update(dt)
    end
    game.world:update(dt)
    camera_mini:setPosition(x,y)
    camSet()
    lapCheck()
    love.window.setTitle(tostring(love.timer.getFPS()))
end 

function love.keypressed(key,isrepeat) --Callback function triggered when a key is pressed.
    if key=="r" then
        if game.car.isAICtrl then
            game.car.isAICtrl=false
        else
            game.car.isAICtrl=true
        end
    end
end

function love.mousepressed(x,y,button) --Callback function triggered when a mouse button is pressed.

end 

--[[
function love.quit() --Callback function triggered when the game is closed.
end 
function love.resize(w,h) --Called when the window is resized.
end 
function love.textinput(text) --Called when text has been entered by the user.
end 
function love.threaderror(thread, err ) --Callback function triggered when a Thread encounters an error.
end 
function love.visible() --Callback function triggered when window is shown or hidden.
end 
function love.mousefocus(f)--Callback function triggered when window receives or loses mouse focus.
end
function love.mousepressed(x,y,button) --Callback function triggered when a mouse button is pressed.
end 
function love.mousereleased(x,y,button)--Callback function triggered when a mouse button is released.
end 
function love.errhand(err) --The error handler, used to display error messages.
end 
function love.focus(f) --Callback function triggered when window receives or loses focus.
end 
function love.keypressed(key,isrepeat) --Callback function triggered when a key is pressed.
end
function love.keyreleased(key) --Callback function triggered when a key is released.
end 
function love.run() --The main function, containing the main loop. A sensible default is used when left out.

    if love.math then
        love.math.setRandomSeed(os.time())
        for i=1,3 do love.math.random() end
    end

    if love.event then
        love.event.pump()
    end

    if love.load then love.load(arg) end

    -- We don't want the first frame's dt to include time taken by love.load.
    if love.timer then love.timer.step() end

    local dt = 0

    -- Main loop time.
    while true do
        -- Process events.
        if love.event then
            love.event.pump()
            for e,a,b,c,d in love.event.poll() do
                if e == "quit" then
                    if not love.quit or not love.quit() then
                        if love.audio then
                            love.audio.stop()
                        end
                        return
                    end
                end
                love.handlers[e](a,b,c,d)
            end
        end

        -- Update dt, as we'll be passing it to update
        if love.timer then
            love.timer.step()
            dt = love.timer.getDelta()
        end

        -- Call update and draw
        if love.update then love.update(dt) end -- will pass 0 if love.timer is disabled

        if love.window and love.graphics and love.window.isCreated() then
            love.graphics.clear()
            love.graphics.origin()
            if love.draw then love.draw() end
            love.graphics.present()
        end

        if love.timer then love.timer.sleep(0.001) end
    end
end
]]